package swinggrapheditor.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class DataSource {

    private DataSource() {
    }

    public static DataSource getInstance() {
        return DataSourceHolder.INSTANCE;
    }

    private static class DataSourceHolder {

        private static final DataSource INSTANCE = new DataSource();
    }
    private final String url = "jdbc:mysql://lengyel.inf.elte.hu:3306/graph", // ELTE-én belülről
    //private final String url = "jdbc:mysql://localhost:13306/graph", // ELTE-én kívülről - ssh tunnel
            user = "graph", password = ""; // az üres jelszó meg fog szűnni, mihelyt bárki olyan dolgot csinál, ami nekem nem tetszik :P

    private Connection getConnection() throws SQLException {
        return DriverManager.getConnection(url, user, password);
    }

    private void ensureNicknameExists(String nickname) throws SQLException {
        try (
                Connection connection = getConnection();
                PreparedStatement preparedStatement = connection.prepareStatement("INSERT INTO GRAPH VALUES (?, ?)");) {
            preparedStatement.setString(1, nickname);
            preparedStatement.setString(2, "");
            try {
                preparedStatement.execute();
            } catch (SQLException sqle) {
            }
        }
    }

    public String loadGraph(String nickname) throws SQLException {
        ensureNicknameExists(nickname);
        String xmlString;
        try (
                Connection connection = getConnection();
                PreparedStatement preparedStatement = connection.prepareStatement("SELECT XML_STRING FROM GRAPH WHERE NICKNAME = ?");) {
            preparedStatement.setString(1, nickname);
            try (ResultSet resultSet = preparedStatement.executeQuery();) {
                resultSet.next();
                xmlString = resultSet.getString(1);
            }
        }
        return xmlString;
    }

    public void saveGraph(String nickname, String xml) throws SQLException {
        ensureNicknameExists(nickname);
        try (
                Connection connection = getConnection();
                PreparedStatement preparedStatement = connection.prepareStatement("UPDATE GRAPH SET XML_STRING = ? WHERE NICKNAME = ?");) {
            preparedStatement.setString(2, nickname);
            preparedStatement.setString(1, xml);
            preparedStatement.execute();
        }
    }
}
